program GlobalEdit;


uses dos,crt,gentypes,gensubs;

type
     configtype102=(lowercase,eightycols,linefeeds,postprompts,moreprompts,
                 asciigraphics,ansigraphics,udsysop,bulletinsysop,votingsysop,
                 emailsysop,doorssysop,mainsysop,databasesysop,jsysop,
                 gfsysop,wanted,showtime,vt52,fseditor);
     filelist111=(fffname,fffsize,fffpoints,fffuploaded,fffuploader,fffdown,
        fffdescript);       {Configurable file listings}

     filelist120=(ffname,ffext,ffsize,ffpoints,ffuploaded,ffuploader,ffdown,
        ffdescript,fffulnam,ffofwhat);       {Configurable file listings}


var	urec:userrec;
		ufile:file of userrec;
		cnt,n,numusers:integer;
		choice,temp:char;
    TempS:string;
    TempL:longint;



function ratio:word;
var ud,temp:longint;
begin
  temp:=urec.upbytes_all;
  if temp<1 then
     ud:=0
  else
     ud:=(temp) div (urec.dnbytes_all div 100);
  if ud>60000 then ud:=60000;
  if ud<0 then ud:=60000;
  ud:=ud+(urec.upbytes_all div 1000000);
  ratio:=ud;
  end;

  procedure SetLevels(NewLvl:byte);
  begin
    urec.level:=newlvl;
    urec.udlevel:=newlvl;
    end;

procedure evaluate;
var  oldacc:byte;
begin
  oldacc:=(urec.level + urec.udlevel) div 2;
  if (urec.dnbytes_all>1000000) then begin
     case ratio of
       0:SetLevels(20);
       1..5:SetLevels(30);
       6..20:SetLevels(40);
       21..40:SetLevels(50);
       41..80:SetLevels(60);
       81..100:SetLevels(70);
       101..200:SetLevels(80);
       201..60000:SetLevels(90);
       else setlevels(90);
       end;
     if urec.upbytes_all<100000 then
       SetLevels(10);
     writeln(' Ratio: ',ratio,'%, for level ',urec.level,' access - from ',oldacc);
     end
  else
     writeln(' is ineligible for evaluation');
  end;


procedure convert;
 var m,o:integer;
 begin
	case choice of
		'C':with urec do begin
			 regularcolor:=0;
			 promptcolor:=0;
			 statcolor:=0;
			 inputcolor:=0;
			 fifthcolor:=0;
			 sixthcolor:=0;
			 seventhcolor:=0;
			 eighthcolor:=0;

		  end;
    'E':urec.expiration:=Templ;
		'U':urec.userudr:=0;
		'T':with urec do begin
				Uploads_Month:=0;
				Uploads_All:=0;
				Dnloads_Month:=0;
				Dnloads_all:=0;
				UpBytes_Month:=0;
				UpBytes_All:=0;
				DnBytes_Month:=0;
				DnBytes_All:=0;
				end;
    'A':Evaluate;
		end;
 end;


  begin
    clrscr;
    writeln;
    writeln('This utility will do various global editing tasks for Celerity/Alacrity.');
    writeln;
	 writeln('Warning: Make sure you only use this on version 1.39/1.40/1.41');
   writeln('Use ACCESS EVALUATION only on CAE/TAC');
	 writeln;
	 writeln;
    writeln;
	 writeln('You may reset:      [A]ccess Evaluation   [Q]uit');
	 writeln('  [U]/D Ratios      [T]ransfer Stats      [C]olors');
   writeln('  [E]xpiration date');
   writeln('  [1..5] Set Conference Access');
    readln(Choice);
	 choice:=upcase(choice);
	 if choice='Q' then exit;

	 case choice of
		'C':writeln('Setting everyone''s colors to the default.');
		'U':writeln('Setting everyone''s upload/download ratio to 0 (config default)');
		'T':writeln('Clearing everyone''s transfer statistics.');
    'A':writeln('Evaluating access');
    '1'..'5':writeln('Setting conference');
    'E':begin
      writeln('Use the format:  07/15/92');
      write('Set expiration date to:');
      readln(temps);
      TempL:=dateval(temps)+timeval('12:00 AM');
      writeln('Setting to : ',datestr(templ));
      end;
		end;


	 assign (ufile,'USERS');
	 reset (ufile);
	 numusers:=filesize(ufile);
	 writeln;
	 seek(ufile,1);
   window(1,12,80,22);
	 for cnt:=1 to (numusers-1) do begin
		seek(ufile,cnt);
		read(ufile,urec);
		gotoxy(1,10);
		write('User #',cnt+1);
		write('    ',urec.handle);

		clreol;
		convert;
    writeln;
		seek(ufile,cnt);
		write (ufile,urec);
	 end;
	 writeln;
	 writeln('Done Converting');
	 close(ufile);
  end.
