type anystr=string[128];
     lstr=string[80];
     mstr=string[30];
     sstr=string[15];
  	 cstr=string[45];

    accesstype=(bylevel,keepout,letin,invalid);     {Post access}
    availtype=(available,bytime,notavailable);      {Sysop available}
	  configtype=(linefeeds,postprompts,moreprompts,asciigraphics,
       fudsysop,fbulletinsysop,fvotingsysop,femailsysop,fdoorsysop,fmainsysop,
       fdatabasesysop,fNewUserSysop,fgfsysop    );
    boardorder=array [0..255,1..maxconf] of byte;            {Order of subs}
    filelisttype=(ffname,ffext,fffulnam,ffofwhat,ffsize,ffpoints,ffuploader,
                   ffuploaded,ffdown,ffdescript);   {Configurable file listings}
    NuvSet=set of 1..255;

type userrec=record          {Version 1.40}
     UserID:longint;         {User identification number}
     handle:mstr;            {User's handle}
     realname:mstr;          {User's real first/last name}
     InterNetName:sstr;      {name for internet mail}
     Signature:lstr;         {User's signature}
     Address:array[1..2] of mstr; {Street Address}
     macro:array[1..3] of mstr;  {Macros}
		 note:mstr;              {User note:  'Sysop of XXX' etc.}
     PrivNote:lstr;          {Sysop note}
		 password:sstr;          {Password}
		 phonenum:string[12];    {Phone #.  If blank, user will be prompted}
		 laston:longint;         {Last time on in PackTime format}
     NumCalls,               {Number of calls to system}
		 temp1:integer;
		 totaltime:real;         {Total time spent on board}
		 udlevel,		       			 {Xfer section access level}
		 level,                  {Main BBS access level  -5 through 100}
		 HelpLevel:integer;      {Novice / Expert Mode}
		 udpoints:longint;       {Current file points}
     Access:Longint;         {Access flags} {for next ver}

     SpareLongs:array[1..8] of longint;  {unused}

     AutoChatCall:boolean;   {Call chat upon login}
		 infoforms:array[1..5] of integer;
										 {Location values for Infoforms.  Set to -1}
		 regularcolor,           {User's color values.  Setting to 0 will}
		 promptcolor,            {cause system to remap them to the current}
		 statcolor,              {defaults, as set in config.}
		 inputcolor,
		 fifthcolor,
		 sixthcolor,
		 seventhcolor,
		 eighthcolor,

		 displaylen:byte;        {User's display length.  20-50 lines.}
		 lastmessages,           {Used for determining "how many new posts"}
		 lastups:integer;        {'' "new uploads"}
     SingleKey:boolean;      {use single key input}
		 defproto:char;           {Default xfer protocol.  Character.}
		 hack:byte;              {Hack attempts since last call.  If >5, ask for phone #}
     config:set of configtype;
                               {Certain configuration options for user/access}
     newscanconfig,          {User subboard newscan data}
     access1,                {User access flags for subs}
     access2:set of byte;    {Second access flag set for subs}
		 lastread:array [0..40,1..maxconf] of word;
										 {Last post read on each sub}
     confaccess: array [0..maxconf] of boolean;
										 {Conference access flags}
     XferConfAccess:array[0..maxconf] of boolean;
     XferScan:array[0..50,0..maxconf] of boolean; {xfer scan flags}
		 lastcps,                {Average cps rate for downloading}
		 cpstimes:word;          {Times counted for average}
		 filelister:array[1..3] of set of filelisttype;
										 {File listing configuration}
     CurList:byte;           {Which list currently in use?}
		 commpoints,             {Points gained via commission since last call}
		 valpoints:integer;      {Points gained from validation since last call}
		 ScanNet:boolean;        {Flag to scan CelerityNet subs or not}
		 quikconf:array[1..maxconf] of boolean;
										 {Quickscan conferences flags}
     QuikXferConf:array[1..maxconf] of boolean;
                     {Quickscan xfer conferences}
		 userpcr,                {Individual post/call ratio.  0=use default}
		 userudr,                {Individual upload/download ratio.  0=default}
		 usergenr,               {General ratio}
		 age:byte;               {User's age.  6-89.  If less than 0, user will
          									  be prompted for both age and sex}
     usersex:boolean;        {True=female.  Approved by Deanna Elizalda, Feminist}
		 Expiration,             {Date of account expiration}
		 birthdate:longint;      {date of birth}
		 voteyes,                {Number of votes cast for validation in NUV}
		 voteno:byte;            {Number against user in NUV}
		 timeperday:byte;        {Individual user's time per day.  0=default by lvl}
		 Posts_Month,
		 Posts_all,
		 Uploads_Month,
		 Uploads_All,
		 Dnloads_Month,
		 Dnloads_all:integer;
		 UpBytes_Month,
		 UpBytes_All,
		 DnBytes_Month,
		 DnBytes_All:longint;
		 PBytes_All,
		 PBytes_Month:longint;
		 KperDay,
		 KToday:Word;
		 NoNet:boolean;          {Deny net access}
		 Exempt:array[1..5] of boolean;
                     {1-pcr, 2=udr, 3=genr, 4=, 5=xfer}
		 SpecialAccess:boolean;
     AutoQwk:boolean;        {Auto-create QWK Packet}
     QwkUpdate:boolean;      {Update Pointers in QWK packet}
     QwkPacker:char;         {code for QWK packer}
     UseYesNo,
     UseFloatPrompt,
     UseColor:boolean;
     UseSignature:boolean;
     UseFSE:boolean;
     PermitPaging:boolean;
     ActivityLogging:boolean;{unused}
     TermEmul:byte;          {0=none, 1=vt52, 2=vt52 Atari, 3=vt100, 4=ANSI,
                              5=Avatar level 0}
     SysopFlags:longint;     {sysop flags #1 to 32}
     AreaAccess:longint;
     VoteData:array[1..8] of byte;   {vote data - nybbles}
     TimeCredit:longint;     {Time credit remaining today}
     temp4,
     temp5,
     temp6:longint;
	  end;

